(*########################################################################*)
(*                                              *)
(*                                                                        *)
(*########################################################################*)

program bciprocessing;

uses crt;

const n = 500;
      fileid = '1995';

var matrix,m : array[1..n,1..n] of longint;
    coordx : array[1..500000] of real;
    coordy : array[1..500000] of real;
    sizes : array [1..100] of real;
    counts : array [1..100] of longint;

    id: array[1..300000] of string;
    numid: array[1..300000] of longint;
    spind: array[1..300000] of longint;

    preston_size,preston_nr,abund: array[1..n*n] of longint;
    probdens,probdens1,meanabund: array[1..n*n] of real;
    prk: longint;

    i,j,k,nr,u,v,s,spnr,indnr,nrsize,maxIndNr : longint;
    datafile : string;
    f: text;
    length,D,t1,t2,t3,t4,t5,corr,ste,b : real;

procedure read_data(datafile:string);
var f : text;
    x,y : real;
    i,j,found : integer;
    s : string;
begin
      write('> reading ',datafile,' ... ');
      assign(f,datafile);
      reset(f);

      indnr:=0;
      spnr:=0;
      while (not(eof(f))) do
      begin
         read(f,x);
         read(f,y);
         read(f,s);
         indnr:=indnr+1;
         coordx[indnr]:=x-500;
         coordy[indnr]:=y;
         id[indnr]:=s;

         found:=0;
         for i:=1 to indnr-1 do
               if (s=id[i]) then begin found:=1; numid[indnr]:=numid[i]; break; end;

         if (found=0) then begin inc(spnr); numid[indnr]:=spnr; end;
      //   writeln(x,' ',y,' ',s);
      end;
      close(f);
      writeln('ok');
      writeln('Nr of individuals: ',indnr);
      writeln('Nr of species: ',spnr);

      
      for i:=1 to spnr do
         spind[i]:=0;
      for i:=1 to indnr do
         inc(spind[numid[i]]);
      maxIndNr:=0;
      for i:=1 to spnr do
         if spind[i]>maxIndNr then maxIndNr:= spind[i];
      writeln('Nr of individuals in largest species: ',maxIndNr);
      writeln('Relative size of most abundant species: ',maxIndNr/indnr:8:3);

  {    j:=0;
      for i:=1 to spnr do
         j:=j+spind[i];
      writeln(j);    }

  {    for i:=1 to indnr do
         writeln(coordx[i],' ',coordy[i],' ',id[i],' ',numid[i]); }
end; { read_data }

procedure species_area;
var size,nrofsp,k:longint;
    startx,starty,endx,endy:real;
    spind: array[1..10000] of longint;
    areanr:longint;
    areasp:real;
    f:text;
    filename:string;
begin
   filename:='bcihalf'+fileid+'sar.dat';
   assign(f,filename);
   rewrite(f);

   randomize;
   size:=10;
   while (size<n) do
   begin
   areasp:=0;
   areanr:=0;

   for k:=1 to 10000 do
   begin
   repeat
      startx:=random()*500;
   until (startx+size<=500);
   repeat
      starty:=random()*500;
   until (starty+size<=500);
   //writeln(startx,' ',starty);
   endx:=startx+size;
   endy:=starty+size;

   for i:=1 to spnr do
     spind[i]:=0;
   for i:=1 to indnr do
     if (coordx[i]>=startx) and (coordx[i]<=endx) and (coordy[i]>=starty) and (coordy[i]<=endy) then
     begin
       // writeln(coordx[i],' ',coordy[i],' ',id[i],' ',numid[i]);
        inc(spind[numid[i]]);
     end;
   nrofsp:=0;
   for i:=1 to spnr do
     if spind[i]>0 then inc(nrofsp);
   areasp:=areasp+nrofsp;
 //  writeln(nrofsp);
   inc(areanr);
   end;
   writeln(size,' ',areanr,' ',areasp/areanr:8:2);
   writeln(f,size,' ',areasp/areanr:8:2);
   size:=size+10;
   end;
   writeln(f,n,' ',spnr/1.0:8:2);
   close(f);
end;{species_area}

procedure species_areaHa;
var nrofsp,k:longint;
    startx,starty,endx,endy:real;
    spind: array[1..10000] of longint;
    areanr:longint;
    areasp,size:real;
    f:text;
    filename:string;
begin
   filename:='bcihalf'+fileid+'sarHa.dat';
   assign(f,filename);
   rewrite(f);

   randomize;
   size:=5;
   while (size<n) do
   begin
   areasp:=0;
   areanr:=0;

   for k:=1 to 10000 do
   begin
   repeat
      startx:=random()*500;
   until (startx+size<=500);
   repeat
      starty:=random()*500;
   until (starty+size<=500);
   //writeln(startx,' ',starty);
   endx:=startx+size;
   endy:=starty+size;

   for i:=1 to spnr do
     spind[i]:=0;
   for i:=1 to indnr do
     if (coordx[i]>=startx) and (coordx[i]<=endx) and (coordy[i]>=starty) and (coordy[i]<=endy) then
     begin
       // writeln(coordx[i],' ',coordy[i],' ',id[i],' ',numid[i]);
        inc(spind[numid[i]]);
     end;
   nrofsp:=0;
   for i:=1 to spnr do
     if spind[i]>0 then inc(nrofsp);
   areasp:=areasp+nrofsp;
 //  writeln(nrofsp);
   inc(areanr);
   end;
   writeln(size*size/10000:8:3,' ',areanr,' ',areasp/areanr:8:2);
   writeln(f,size*size/10000:8:3,' ',areasp/areanr:8:2);
   size:=size*1.2;
   end;
   writeln(f,n*n/10000:8:3,' ',spnr/1.0:8:2);
   close(f);
end;{species_areaHa}

procedure preston;
var f : text;
    i,j,k: longint;
    s:string;
begin
   preston_size[1]:= 2;
   preston_nr[1]:= 0;
   prk:= trunc( ln(maxIndNr)/ln(2) )+1;
   for i:=2 to prk do
   begin
      preston_size[i]:= preston_size[i-1]*2;
      preston_nr[i]:= 0;
   end;

   for i:=1 to spNr do
   begin
      k:=1; j:=2;
      while (j<=spind[i]) do
      begin
         inc(k);
         j:=j*2;
      end;
      inc(preston_nr[k]);
   end;

   // save data to preston[ ].dat
   s:='bcihalf'+fileid+'preston.dat';
   assign(f,s);
   rewrite(f);
   k:=1;
   for i:=1 to prk do
   begin
      writeln(f,k{preston_size[i]},' ',preston_nr[i]);
      inc(k);
   end;
   close(f);
   writeln('Number of Preston intervals: ',prk);
end;

procedure rank_abundance;
var f : text;
    i,j,k: longint;
    s:string;
begin
   for i:=1 to spNr do
   begin
      abund[i]:= spind[i];
   end;

   for i:=1 to spnr-1 do
      for j:=i+1 to spnr do
         if abund[i]<abund[j] then
         begin
            k:= abund[i];
            abund[i]:= abund[j];
            abund[j]:= k;
         end;

   {for i:= 1 to spNr do
   write(abund[i],' ');  }

   // save data to rank_ab[ ].dat
   s:='bcihalf'+fileid+'rank_ab.dat';
   assign(f,s);
   rewrite(f);
   for i:=1 to spNr do
   begin
      writeln(f,abund[i],' ',i);
   end;
   close(f);
end;

procedure distrib;
var f : text;
    i,j,k,ii,jj: longint;
    s:string;
    sum:real;
begin
   prk:= trunc( ln(maxIndNr)/ln(2) )+1;
   for i:=1 to prk do
   begin
      meanabund[i]:= 0;
      preston_nr[i]:= 0;
   end;

   for i:=1 to spNr do
   begin
      k:=1; j:=2;
      while (j<=spInd[i]) do
      begin
         inc(k);
         j:=j*2;
      end;
      inc(preston_nr[k]);
      meanabund[k]:= meanabund[k]+spInd[i];
   end;

{   sum:=0;
   for i:=1 to prk do
   begin
   writeln(meanabund[i],' ',preston_nr[i]);
   sum:= sum+meanabund[i];
   end;
   writeln(sum);   }

   ii:= 0;
   jj:= 2;
   for i:=1 to prk do
   begin
      probdens[i]:= meanabund[i]/indNr/(jj-ii);
      probdens1[i]:= preston_nr[i]/spNr/(jj-ii);
      if (preston_nr[i]>0) then meanabund[i]:= meanabund[i]/preston_nr[i]
                           else meanabund[i]:=0;
      ii:=jj;
      jj:=jj*2;
   end;

   // save data to probdens[ ].dat
   s:='bcihalf'+fileid+'probdens.dat';
   assign(f,s);
   rewrite(f);
   for i:=1 to prk do
   begin
      writeln(f,meanabund[i],' ',probdens1[i],' ',probdens[i]);
   end;
   close(f);

{  for i:=1 to prk do
      writeln(meanabund[i],' ',probdens1[i],' ',probdens[i]);}
end;


procedure info;
var f : text;
    s:string;
begin
   // save data to info[ ].dat
   s:='bcihalf'+fileid+'info.dat';
   assign(f,s);
   rewrite(f);
   writeln(f,'Number of different species: ',spNr);
   writeln(f,'Total number of individuals: ',indNr);
   writeln(f,'Nr of individuals of most abundant species: ',maxIndNr);
   writeln(f,'Relative size of most abundant species: ',maxIndNr/indNr:8:3);
   writeln(f,'Number of Preston intervals: ',prk);
   close(f);
end;

Begin
  { writeln('Proba indul');
   count_species('bci1985.dat'); }
   //val(paramstr(1),job,error1);
   //infileid:= paramstr(1);

   datafile:='bcihalf'+fileid+'clean.dat';
   read_data(datafile);

   preston;      writeln('ok preston');
   rank_abundance;  writeln('ok rank_ab');
   distrib;        writeln('ok probdens');
   info;              writeln('ok info');
   species_area;        writeln('ok species_area');
   species_areaHa;        writeln('ok species_areaHa');

End.


